unit datum_u;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

const
  PocetMesicu = 12;

type
  datum = record
    den, mesic, rok: integer;
  end;

function prestupny_rok(rok: integer): Boolean;
function cislo_dne(dnes: datum): integer;
function kontrola(dnes: datum): Boolean;
function zitra(dnes: datum): datum;

implementation

var
  pocet_dnu_v_mesici: array[1..PocetMesicu] of integer =
         (31, 28, 31,30, 31, 30, 31, 31, 30, 31, 30, 31);
  pocet_dnu_do_zacatku_mesice: array[1..PocetMesicu] of integer;

procedure inicializace;
var i: integer;
begin
   pocet_dnu_do_zacatku_mesice[0] := 0;
   for i := 2 to PocetMesicu do
   begin
     pocet_dnu_do_zacatku_mesice[i] := pocet_dnu_do_zacatku_mesice[i - 1] + pocet_dnu_v_mesici[i - 1];
   end;
end;

function prestupny_rok(rok: integer): Boolean;
begin
   Result := ((rok mod 4 = 0) and (rok mod 100 <> 0)) or (rok mod 400 = 0);
end;

function cislo_dne(dnes: datum): integer;
begin
   with dnes do
   begin
     Result := pocet_dnu_do_zacatku_mesice[mesic] + den;
     if (mesic > 2) and prestupny_rok(rok) then Result := Result + 1;
   end;
end;

function kontrola(dnes: datum): Boolean;
begin
   Result := True;
   if (dnes.den = 29) and (dnes.mesic = 2) and prestupny_rok(dnes.rok) then
   begin
      exit;
   end;
   if ((dnes.mesic < 1) or (dnes.mesic > PocetMesicu)) or (dnes.den < 1) or (dnes.den > pocet_dnu_v_mesici[dnes.mesic]) then
   begin
      Result := false;
      exit;
   end;
end;

function zitra(dnes: datum): datum;
begin
   result := dnes;
   with result do
   begin
     inc(den);
     if kontrola(result) then exit;
     inc(mesic);
     den := 1;
     if kontrola(result) then exit;
     inc(rok);
     mesic := 1;
   end;
end;

initialization
   inicializace;
end.

